unit _ipPost;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,DBTables,DB;

type
  Tip_Post = class(TComponent)
  private
    { Private declarations }
    FDataSource : TDataSource;
    FCloseEvent : TCloseEvent;
    function GetDataSource: TDataSource;
    procedure SetDataSource(Value: TDataSource);
  protected
    { Protected declarations }
     procedure FormClose(Sender: TObject; var Action: TCloseAction);
     procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    { Public declarations }
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
    function CanClose:Boolean;
  published
    { Published declarations }
    property DataSource: TDataSource read GetDataSource write SetDataSource;
  end;

procedure Register;

//var
 //STable : Tdataset;

implementation

constructor Tip_Post.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
  if (Owner is TForm) and not (csDesigning in ComponentState) then
  begin
    //FShowEvent:=(Owner as TForm).OnShow;
    FCloseEvent:=(Owner as TForm).OnClose;
    //(Owner as TForm).OnShow:=FormShow;
    (Owner as TForm).OnClose:=FormClose;
  end;
end;

destructor Tip_Post.Destroy;
begin
  inherited Destroy;
end;

procedure Tip_Post.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove)  and
    (AComponent = DataSource) then DataSource := nil;
end;

function Tip_Post.GetDataSource: TDataSource;
begin
  Result := FDataSource;
end;

procedure Tip_Post.SetDataSource(Value: TDataSource);
begin
  FDataSource := Value;
   //if Value <> nil then Value.FreeNotification(Self);
end;

procedure Tip_Post.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if not CanClose then
  begin
         Datasource.Dataset.Post;
  end;
  if assigned(FCloseEvent) then  FCloseEvent(SELF,Action);
end;

function Tip_Post.CanClose;
begin
   Result:=True;
   if Datasource=nil then Exit;
   if Datasource.Dataset=nil then Exit;
   if (Datasource.Dataset.State=dsEdit) or (Datasource.Dataset.State=dsInsert) then
      Result:=False;
end;

procedure Register;
begin
  RegisterComponents('_InfoPlus', [Tip_Post]);
end;

end.
